//+-----------------------------------------------------------------------------------------------------------------------------+
//| APPLIED PRICES TYPES:
//+-----------------------------------------------------------------------------------------------------------------------------+
	enum CENUM_APPLIED_PRICE {
	  price_CLOSE,
	  price_OPEN,
	  price_HIGH,
	  price_LOW,
	  price_MEDIAN,
	  price_TYPICAL,
	  price_WEIGHTED,
	  price_AVERAGE,
	  priceHA_CLOSE,
	  priceHA_OPEN,
	  priceHA_HIGH,
	  priceHA_LOW,
	  priceHA_MEDIAN,
	  priceHA_TYPICAL,
	  priceHA_WEIGHTED,
	  priceHA_AVERAGE
	};
//+-------------------------------------------------------------------------------------------------------------------------+
//| ENUM TO DEFINE TREND DIRECTIONs
//+-------------------------------------------------------------------------------------------------------------------------+
	enum CENUM_TREND {
		RANGE,																							// ZeroMemory DEFAULTS THE FIRST VALUE IN ENUM
		LONG,
		SHORT
	};
//+-----------------------------------------------------------------------------------------------------------------------------+
//| BILL WILLIAMS:
//+-----------------------------------------------------------------------------------------------------------------------------+
	struct SiAC {																					// iAC AND iAO SHARE THE SAME STRUCTURE TYPE
		double	value;
		int			valueClr;	
	};
	struct SiAC_TL {																			// STRATEGY DivergeAC: DIVERGENCE TREND LINE STRUCTURE
		double			value;
		double			slope;
	};
	struct SiFractal {
		int 	 idx;
		double value;
	};
	// Used for !!!
	struct fracIDX {
		int idxB;
		int idxA;
		int idxMIN;
	};
//+-----------------------------------------------------------------------------------------------------------------------------+
//| OSCILLATORS:
//+-----------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD MFI VALUES
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiMFI {
				double 	mfi;
				bool		aboveMP;									// [true] ABOVE MID POINT [false] BELOW MID POINT
				bool		isOBought;
				bool		isOSold;
			};
			struct SiMFIDiverg {
				int					idxA;
				int					idxB;
				CENUM_TREND	direction;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD RELATIVE VIGOR INDEX INDICATOR VALUES
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiRVI {
				double	main;
				double	signal;
				bool		inThldUP;
				bool		inThldDN;
			};
			struct SiRVICross {
				int					idx;
				CENUM_TREND	direction;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD STOCHASTIC VALUES
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiStoch {
				double 	main;
				double 	signal;
				bool		isAboveMP;
				bool		isBelowMP;
			};
			struct SiStochRSI {
				double 	stochRSI;
				bool		enterOB;
				bool		exitOB;
				bool		enterOS;
				bool		exitOS;
				bool		overBought;
				bool		overSold;
			};
//+-----------------------------------------------------------------------------------------------------------------------------+
//| TREND:
//+-----------------------------------------------------------------------------------------------------------------------------+
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| TREND: DEFINE TREND DIRECTION
	//+---------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| ENUM TO DEFINE TREND_STRENGTH
		//+-------------------------------------------------------------------------------------------------------------------------+
			enum CENUM_TREND_STRENGTH {
			  NORMAL,																					// ZeroMemory DEFAULTS THE FIRST VALUE IN ENUM
				BEGIN,
			  PULLBACK,
				RETRACEMENT,																		// RETRACEMENT FROM A PULLBACK
			  STRONG,
			  SQUEEZE																					// DEFINE RANGE IS SQUEEZE TYPE
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD TREND PARAMETERS
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct STrend {
				CENUM_TREND						direction;
				CENUM_TREND_STRENGTH	strength;
				int			 							idxStart;
				datetime 							timeStart;
				int										timeElapsed;
				double	 							rangeHigh;
				double	 							rangeLow;
				double	 							rangeAmplitude;
			};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| HEIKEN ASHI CANDLES:
	//+---------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| ENUM TO DEFINE HEIKEN ASHI CANDLE TYPES
		//+-------------------------------------------------------------------------------------------------------------------------+
			enum CENUM_HA_TYPE {
				BEARISH,
				BEAR_DOJI,
				BEAR_STOP,
				BEAR_WEAK,
				BEAR_LW,
				BULLISH,
				BULL_DOJI,
				BULL_STOP,
				BULL_WEAK,
				BULL_LW
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD HA CANDLE PRICE AND OTHER PARAMETERS
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiOHLC {
				double 		open;
				double 		high;
				double 		low;
				double 		close;
			};
			struct SiHA {
				double 				open;
				double 				high;
				double 				low;
				double 				close;
				bool					isBullish;
				bool					isBearish;
				bool					bullWeak;													// EITHER OF BULL_WEAK, BULL_LW, BULL_STOP OR BULL_DOJI
				bool					bearWeak;													// EITHER OF BEAR_WEAK, BEAR_LW, BEAR_STOP OR BEAR_DOJI
				CENUM_HA_TYPE type;
			};
			struct SiHASmooth {
				double 				open;
				double 				high;
				double 				low;
				double 				close;
				CENUM_HA_TYPE type;
				CENUM_TREND		direction;
			};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| DOUBLE BOLLINGER BAND:
	//+---------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| ENUM TO DEFINE DOUBLE BOLLINGER BAND ZONES
		//+-------------------------------------------------------------------------------------------------------------------------+
			enum CENUM_DBB_ZONE {
				BUY,
				NML,																						// ABBREVIATION FOR 'NO MEN's LAND'
				SELL
			};
			struct SCloseZone {
				int					idx;
				CENUM_TREND	zone;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD DOUBLE BOLLINGER BAND PRICES
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiDBB {
				double upperOut;
				double upperInn;
				double base;
				double baseSlope;
				double lowerInn;
				double lowerOut;
				double normBB;
				bool	 isOBought;
				bool	 isOSold;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE FOR pSAR
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiSAR {
				double 			sar;
				CENUM_TREND	direction;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE FOR INDICATOR SUPER TREND (DOUBLE)
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiSuperTrend {
				double 			slow;
				double 			slowclr;
				double 			fast;
				double 			fastclr;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE FOR INDICATOR SUPER TREND HULL
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SiSuperTrendHull {
				double 				slow;
				CENUM_TREND 	slowDirection;
				double 				fast;
				CENUM_TREND 	fastDirection;
			};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| FIBONACCI DAILY PIVOTs:
	//+---------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| ENUM TO DEFINE DEFINE FIBONACCI PIVOT LEVELS
		//+-------------------------------------------------------------------------------------------------------------------------+
			enum CENUM_PIVOT {
				eR10_2618,
				eR9_2000,
				eR8_1618,
				eR7_1382,
				eR6_1236,
				eR5_1000,
				eR4_0786,
				eR3_0618,
				eR2_0382,
				eR1_0236,
				ePIVOT,
				eS1_0236,
				eS2_0382,
				eS3_0618,
				eS4_0786,
				eS5_1000,
				eS6_1236,
				eS7_1382,
				eS8_1618,
				eS9_2000,
				eS10_2618
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD CALCULATED DAILY PIVOT LEVEL PRICES
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SPivots {
			  double R10_2618;
			  double R9_2000;
			  double R8_1618;
			  double R7_1382;
			  double R6_1236;
			  double R5_1000;
			  double R4_0786;
			  double R3_0618;
			  double R2_0382;
			  double R1_0236;
			  double Pivot;
			  double DailyRange;					// DAILY RANGE (HIGH - LOW) VALUE
			  double S1_0236;
			  double S2_0382;
			  double S3_0618;
			  double S4_0786;
			  double S5_1000;
			  double S6_1236;
			  double S7_1382;
			  double S8_1618;
			  double S9_2000;
			  double S10_2618;
			};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| FIBONACCI RETRACEMENT BASED ON HIGH AND LOW PRICES AND TREND DIRECTION
	//+---------------------------------------------------------------------------------------------------------------------------+
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO HOLD PRICE AT FIBO RETRACEMENT LEVELS
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SFiboRT {
				CENUM_TREND		direction;
				datetime			Time1;
				datetime			Time2;
				double 				Retrace_0236;
				double 				Retrace_0382;
				double 				Retrace_0500;
				double 				Retrace_0618;
				double 				Retrace_0786;
			};
		//+-------------------------------------------------------------------------------------------------------------------------+
		//| STRUCTURE TO BE USED IN A CALL TO CALCULATE FIBO EXPANSION PRICEs
		//+-------------------------------------------------------------------------------------------------------------------------+
			struct SFiboEX {
				datetime		timeA;
				double			priceA;			// 100.0% PRICE LEVEL
				datetime		timeB;
				double			priceB;			// 0.0% PRICE LEVEL
				datetime		timeC;
				double			priceC;			// PULLBACK PRICE LEVEL
				CENUM_TREND	direction;
			};
//+-----------------------------------------------------------------------------------------------------------------------------+
//| STRUCTURES USED IN TRADE MANAGE
//+-----------------------------------------------------------------------------------------------------------------------------+
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| STRUCTURE USED IN CLASS: CSignalOpen
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SSignalOpen {
			int					magicNo;
			double			priceTP;
			string			commentEntry;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| STRUCTURE USED IN CLASS: CSignalOpen, CTrailClose
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct STrigFound {
			bool              found;
			datetime          time;
			int               idx;
		};
		struct STrigExit {
			bool              found;
			datetime          time;
			int               idx;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| STRUCTURE USED IN CLASS: CDoubleTop TRIGGER: DOUBLE TOP AND DOUBLE BOTTOM
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SDoubleTop {
			CENUM_TREND direction;
			double 			priceKey;
			double 			priceNL;
			double 			priceFT;
			datetime 		timeStart;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| ENUM AND STRUCTURE USED IN CLASS: CDivergence:
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SDiverge {
			CENUM_TREND 			direction;
			int								idxB;
			int								idxA;
			bool 							isMFI;
			bool 							isStoch;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| STRUCTURE USED TO FIND OSCILLATOR OVER BOUGHT/OVER SOLD CONDITIONS OR CANDLE PATTERN IN MULTIPLE BARS, AND HOLD THE MOST
	//| 					RECENT BAR DETAILS
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SIsFound {
			int			idx;
			bool		found;
			double	price;
		};
//+-----------------------------------------------------------------------------------------------------------------------------+
//| STRUCTURES USED IN INDICATOR CLASS
//+-----------------------------------------------------------------------------------------------------------------------------+
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| CiKB: KELTNERS BAND
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SiKB {
			double upper;
			double lower;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| CiMA: VOLUME WEIGHTED MA AND MOVING AVERAGES
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SiVWMADuplex {
			double slow;
			double fast;
			double slopeFast;
			double slopeSlow;
		};
		struct SiMA {
			double vwma;
			double ma;
			double slopeVWMA;
			double slopeMA;
		};
		struct SiMAHull {
			double 			ma;
			double 			slope;
			CENUM_TREND	trend;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| CiVolume: NORMALIZED AND RVOL VOLUMES
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct sVOL {
			double	rvol;
			int			nvol;
			int			tick;
		};
		struct SiRVOL {
			double	rvol;
			int			tick;
			bool		upper;
			bool		middle;
			bool		lower;
		};
	//+---------------------------------------------------------------------------------------------------------------------------+
	//| CiZigZag: STRUCTURE TO HOLD INDEX AND CORELATED PRICE WHERE INDEX ARE NOT EXCATLY IN BAR NUMBER SEQUENCE
	//+---------------------------------------------------------------------------------------------------------------------------+
		struct SZigZag {
			int 	 idx;
			double price;
		};


//+-----------------------------------------------------------------------------------------------------------------------------+
/* seems unused structures

	// TRIGGER: DIVERGENCE
	struct SDivergence {
		CENUM_TREND		direction;
		double				keyPrice;
		datetime			timeStart;
		int						timeElapsed;
	};

	// BISECTION: OF BAR(s) BY VWMA, MA AND DBB BASE
	struct SBisectedByMAnBase{
		bool		isBisected;
		int			idx;
	};
*/

/*
https://www.mql5.com/en/forum/61741/page3#comment_5491344

#define MIN_ENUM_VALUES 0
#define MAX_ENUM_VALUES 255
//+------------------------------------------------------------------+
//| StringToEnum : Convert a string to an ENUM value,                |
//|   it loop between min(0) and max(255), adjustable if needed.     |
//|   Non existing enum value defined as -1. If -1 is used as an     |
//|   enum value, code need to be adjusted to an other default.      |
//| Parameters :                                                     |
//|   in       - string to convert                                   |
//|   out      - ENUM value                                          |
//|   @return  - true if conversion succeed, false otherwise         |
//+------------------------------------------------------------------+
template<typename ENUM>
bool StringToEnum(string in,ENUM &out)
  {
   out=-1;
//---
   for(int i=MIN_ENUM_VALUES;i<=MAX_ENUM_VALUES;i++)
     {
      ENUM enumValue=(ENUM)i;
      if(in==EnumToString(enumValue))
        {
         out=enumValue;
         break;
        }
     }
//---
   return(out!=-1);
  }
Usage example :

//+------------------------------------------------------------------+
//| testing enums                                                    |
//+------------------------------------------------------------------+
enum ENUM_TEST
  {
   FIRST_CASE=1,
   SECOND_CASE=2

  };
//---
enum ENUM_ANOTHER_TEST
  {
   CASE_ONE,
   CASE_TWO,
   CASE_THREE
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void  OnStart()
  {
   ENUM_TEST which;
   if(!StringToEnum("SECOND_CASE",which)) return;

   ENUM_ANOTHER_TEST which_other;
   if(!StringToEnum("CASE_ONE",which_other)) return;

   ENUM_TEST wrongwhich;
   if(!StringToEnum("blah blah",wrongwhich)) return;

//---
  }
*/